# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_gcj_support 1

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section		free
%define j2ee12  %{?_with_j2ee12:1}%{!?_without_j2ee12:0}
%define j2ee13  %{?_with_j2ee13:1}%{!?_without_j2ee13:0}

Name:		mockobjects
Version:	0.09
Release:	14jpp.3.XOS.1
Epoch:		0
Summary:	Java MockObjects package
License:	BSD Style
URL:		http://www.mockobjects.com/
Group:		Development/Testing
Source0:	http://www.mockobjects.com/dist/%{name}-%{version}-RHCLEAN.tar.bz2
Patch0:		%{name}-buildjdk.patch
Patch1:		%{name}-ext-httpmethod-abstract.patch
Patch2:		%{name}-AssertMo.patch
Requires:	junit
Requires:	/usr/sbin/update-alternatives
BuildRequires:	ant >= 1.6.1
BuildRequires:	ant-junit
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	java-devel >= 1.4.0
BuildRequires:	java-devel < 1.5
BuildRequires:	junit
%if %{j2ee12}
BuildRequires:	j2sdkee-1.2-sun
%endif
%if %{j2ee13}
BuildRequires:	j2sdkee-1.3-sun
%endif
%if ! %{gcj_support}
BuildArch:	noarch
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if %{gcj_support}
BuildRequires:		java-gcj-compat-devel
Requires(post):		java-gcj-compat
Requires(postun):	java-gcj-compat
%endif

%description
The Mock Objects project is a generic unit testing framework whose goal
is to facilitate developing unit tests in the mock object style. The
goal of this project is to provide, a core mock objects framework. This
is a library of code that supports the implementation of mock objects.
It is based around a set of expectation classes for values and
collections. There are also various other classes to make mock objects
easier to write or to use.

%package jdk1.4
Summary:	MockObjects for 1.4 JDK
Group:		Development/Testing
Requires:	/usr/sbin/update-alternatives
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%if %{gcj_support}
BuildRequires:		java-gcj-compat-devel
Requires(post):		java-gcj-compat
Requires(postun):	java-gcj-compat
%endif

%description jdk1.4
MockObjects specific to JDK 1.4.x

%package httpclient
Summary:	MockObjects for Commons HttpClient
Group:		Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	/usr/sbin/update-alternatives
Requires:	jakarta-commons-httpclient

%if %{gcj_support}
BuildRequires:		java-gcj-compat-devel
Requires(post):		java-gcj-compat
Requires(postun):	java-gcj-compat
%endif

%description httpclient
MockObjects for Jakarta Commons HttpClient

%package alt-httpclient
Summary:        Mockable API for Commons HttpClient
Group:          Development/Testing
Requires:       /usr/sbin/update-alternatives
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-httpclient = %{epoch}:%{version}-%{release}
Requires:	jakarta-commons-httpclient

%if %{gcj_support}
BuildRequires:		java-gcj-compat-devel
Requires(post):		java-gcj-compat
Requires(postun):	java-gcj-compat
%endif

%description alt-httpclient
Alternative API for Jakarta Commons HttpClient to allow for testing

%package alt-jdk1.4
Summary:        Mockable API for JDK 1.4
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.4 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%if %{gcj_support}
BuildRequires:		java-gcj-compat-devel
Requires(post):		java-gcj-compat
Requires(postun):	java-gcj-compat
%endif

%description alt-jdk1.4
Alternative API for JDK 1.4 to allow for testing

%package jdk1.4-j2ee1.2
Summary:        Mockable J2EE API for JDK 1.4 and J2EE 1.2
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.4 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%if %{gcj_support}
BuildRequires:		java-gcj-compat-devel
Requires(post):		java-gcj-compat
Requires(postun):	java-gcj-compat
%endif

%description jdk1.4-j2ee1.2
API for JDK 1.4 to allow testing with J2EE 1.2 mocks

%package jdk1.4-j2ee1.3
Summary:        Mockable J2EE API for JDK 1.4 and J2EE 1.3
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.4 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%if %{gcj_support}
BuildRequires:		java-gcj-compat-devel
Requires(post):		java-gcj-compat
Requires(postun):	java-gcj-compat
%endif

%description jdk1.4-j2ee1.3
API for JDK 1.4 to allow testing with J2EE 1.3 mocks

%prep
%setup -q -n %{name}-%{version}
%patch0
%patch1 -p1
%patch2

%build

# build with (almost) empty CLASSPATH
CLASSPATH=`build-classpath junit` ant -buildfile build.xml -Dbuild.compiler=modern jar-core

#JVM extensions

for vm in 0 1 2; do
    if [ -e %{_jvmdir}/java-1.4.${vm}/bin/javac ]; then
	VM_14=${vm}
    fi
done

CLASSPATH=`build-classpath junit` JAVA_HOME=%{_jvmdir}/java-1.4.${VM_14} ant -buildfile build.xml -Dbuild.compiler=modern jar-jdk

#Httpclient extensions
CLASSPATH=`build-classpath jakarta-commons-httpclient junit` ant jar-ext-httpclient

%if %{j2ee12}
rm -rf out/j2ee/classes/*
CLASSPATH=`build-classpath j2ee-1.2 junit` JAVA_HOME=%{_jvmdir}/java-1.4.${VM_14} ant -buildfile build.xml -Dbuild.compiler=modern -Djdk.version=1.4 -Dj2ee.version=1.2 compile-j2ee jar-j2ee
%endif

%if %{j2ee13}
rm -rf out/j2ee/classes/*
CLASSPATH=`build-classpath j2ee-1.3 junit` JAVA_HOME=%{_jvmdir}/java-1.4.${VM_14} ant -buildfile build.xml -Dbuild.compiler=modern -Djdk.version=1.4 -Dj2ee.version=1.3 compile-j2ee jar-j2ee
%endif

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
mkdir -p $RPM_BUILD_ROOT%{_javadir}{-1.4.0,-1.4.1,-1.4.2}
mkdir -p $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-{,alt-}jdk1.4

pushd out
install -m 644 %{name}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-core-%{version}.jar
install -m 644 %{name}-httpclient.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-httpclient-%{version}.jar
install -m 644 alt-httpclient.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-alt-httpclient-%{version}.jar

# Install JDK Mocks and alternatives
install -m 644 %{name}-jdk1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4/%{name}-%{version}.jar
install -m 644 %{name}-alt-jdk1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.4/%{name}-alt-%{version}.jar

# Install J2EE Mocks
%if %{j2ee12}
install -m 644 %{name}-jdk1.4-j2ee1.2-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.2-%{version}.jar
%endif

%if %{j2ee13}
install -m 644 %{name}-jdk1.4-j2ee1.3-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.3-%{version}.jar
%endif

popd

pushd $RPM_BUILD_ROOT%{_javadir} 
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.4
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd


for EXTENSION_VM in 1.4.0 1.4.1 1.4.2; do
   EXTENSION_PREFIX=$(echo $EXTENSION_VM | sed -e 's/1\.\([4]\)\.[0-9]/1.\1/')
   pushd $RPM_BUILD_ROOT%{_javadir}-${EXTENSION_VM}
      ln -sf %{_javadir}-ext/%{name}-jdk${EXTENSION_PREFIX}/%{name}-%{version}.jar  .
      ln -sf %{_javadir}-ext/%{name}-alt-jdk${EXTENSION_PREFIX}/%{name}-alt-%{version}.jar .
%if %{j2ee12}
      ln -sf %{_javadir}-ext/%{name}-jdk${EXTENSION_PREFIX}/%{name}-j2ee1.2-%{version}.jar  .
%endif
%if %{j2ee13}
      ln -sf %{_javadir}-ext/%{name}-jdk${EXTENSION_PREFIX}/%{name}-j2ee1.3-%{version}.jar  .
%endif
      for jar in *-%{version}.jar; do
         ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
      done
    popd
done

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post jdk1.4
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun jdk1.4
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%post httpclient
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun httpclient
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%post
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%post alt-httpclient
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun alt-httpclient
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%post alt-jdk1.4
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun alt-jdk1.4
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc doc/README
%{_javadir}/%{name}-core*

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mockobjects-core-0.09.jar.*
%endif

%files jdk1.4
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-jdk1.4/%{name}-%{version}.jar
%{_javadir}-ext/%{name}-jdk1.4/%{name}.jar
%{_javadir}-1.4.0/%{name}-%{version}.jar
%{_javadir}-1.4.0/%{name}.jar
%{_javadir}-1.4.1/%{name}-%{version}.jar
%{_javadir}-1.4.1/%{name}.jar
%{_javadir}-1.4.2/%{name}-%{version}.jar
%{_javadir}-1.4.2/%{name}.jar

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mockobjects-0.09.jar.*
%endif

%files httpclient
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-httpclient*

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mockobjects-httpclient-0.09.jar.*
%endif

%files alt-jdk1.4
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-alt-jdk1.4/*
%{_javadir}-1.4.0/%{name}-alt-%{version}.jar
%{_javadir}-1.4.0/%{name}-alt.jar
%{_javadir}-1.4.1/%{name}-alt-%{version}.jar
%{_javadir}-1.4.1/%{name}-alt.jar
%{_javadir}-1.4.2/%{name}-alt-%{version}.jar
%{_javadir}-1.4.2/%{name}-alt.jar

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mockobjects-alt-0.09.jar.*
%endif

%files alt-httpclient
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-alt-httpclient*

%if %{j2ee12}
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mockobjects-alt-httpclient-0.09.jar.*
%endif

%files jdk1.4-j2ee1.2
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.2-%{version}.jar
%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.2.jar
%{_javadir}-1.4.0/%{name}-j2ee1.2-%{version}.jar
%{_javadir}-1.4.0/%{name}-j2ee1.2.jar
%{_javadir}-1.4.1/%{name}-j2ee1.2-%{version}.jar
%{_javadir}-1.4.1/%{name}-j2ee1.2.jar
%{_javadir}-1.4.2/%{name}-j2ee1.2-%{version}.jar
%{_javadir}-1.4.2/%{name}-j2ee1.2.jar
%endif

%if %{j2ee13}
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mockobjects-alt-httpclient-0.09.jar.*
%endif

%files jdk1.4-j2ee1.3
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.3-%{version}.jar
%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.3.jar
%{_javadir}-1.4.0/%{name}-j2ee1.3-%{version}.jar
%{_javadir}-1.4.0/%{name}-j2ee1.3.jar
%{_javadir}-1.4.1/%{name}-j2ee1.3-%{version}.jar
%{_javadir}-1.4.1/%{name}-j2ee1.3.jar
%{_javadir}-1.4.2/%{name}-j2ee1.3-%{version}.jar
%{_javadir}-1.4.2/%{name}-j2ee1.3.jar
%endif

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mockobjects-alt-httpclient-0.09.jar.*
%endif

%changelog
* Fri Sep 14 2007 X/OS Linux Team <xoslinux@xos.nl> - 0:0.09-14jpp.3.XOS.1
- Build for X/OS Linux 5.
- X/OS Linux source rpm based on mockobjects-0.09-14jpp.3.src.rpm
  (md5sum of original source rpm: dcd974f6aa4c31b1333980d9e513f715).

* Thu Aug 10 2006 Matt Wringe <mwringe at redhat.com> - 0.09-14jpp.3
- Rebuilt with new naming convention

* Sat Jul 22 2006 Jakub Jelinek <jakub@redhat.com> - 0.09-14jpp_2fc
- Rebuilt

* Fri Jul 21 2006 Matt Wringe <mwringe at redhat.com> 0.09-14jpp_1fc
- Merge with upstream version
- Natively compile packages

* Fri Jul 21 2006 Matt Wringe <mwringe at redhat.com> 0.09-14jpp
- Add conditional native compiling
- Remove unnecessary provides and empty %pre and %post section

* Fri Apr 28 2006 Fernando Nasser <fnasser@redhat.com> 0.09-13jpp
- First JPP 1.7 build

* Mon Dec 13 2004 Ralph Apel <r.apel at r-apel.de> 0.09-12jpp
- Build j2ee mockobjects

* Thu Sep 23 2004 Ralph Apel <r.apel at r-apel.de> 0.09-11jpp
- Optionally activate j2ee mockobjects

* Mon Aug 23 2004 Fernando Nasser <fnasser@redhat.com> 0.09-10jpp
- Remove support for 1.3 SDK
- Rebuild with Ant 1.6.2

* Tue May 18 2004 Paul Nasrat <pauln@truemesh.com> 0.09-9jpp
- Fix spurious 1.4.1 requires in jdk14

* Thu Jun 26 2003 Paul Nasrat <pauln@truemesh.com> 0.09-8jpp
- Re-jigged alt/jvm symlinks to jars rather than dirs

* Tue Jun 24 2003 Paul Nasrat <pauln@truemesh.com> 0.09-7jpp
- Multi jvm symlinks

* Thu Jun 19 2003 Paul Nasrat <pauln@truemesh.com> 0.09-6jpp
- Use java-ext for JDK specific extensions/alternatives

* Thu Jun 19 2003 Paul Nasrat <pauln@truemesh.com> 0.09-5jpp
- Split alternative APIs - as advised by Jeff Martin

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-4jpp
- BuildRequires sdk rather than jdk

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-3jpp
- BuildRequires multiple jdk

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-2jpp
- Broken up into subpackages
- Patch to build jdk-jar (commited upstream)
- Patch to build httpclient (discussed with upstream)

* Wed Mar 05 2003 Jeff Martin <jeff@custommonkey.org> 0.08-1
- first release
